#include<cstdio>
#include<cstdlib>
#include<cassert>
#include<vector>
#include<algorithm>
#include<cmath>

using namespace std;

#define INF 1000000000000000000LL
#define MAXN 20003
long long L, S, A, B;
long long a[MAXN], b[MAXN];

vector<int> ans[MAXN];
int print_ans() {
  vector< pair<int, int> > v;
  for (int i = 0; i < A; ++i) for (int j = 0; j < ans[i].size(); ++j) {
    v.push_back(make_pair(i + 1, ans[i][j] + 1));
  }
  printf("%d\n", (int)v.size());
  for (int i = 0; i < v.size(); ++i) {
    swap(v[i], v[rand() % (i + 1)]);
  }
  for (int i = 0; i < v.size(); ++i) {
    printf("%d %d\n", v[i].first, v[i].second);
  }
  return 0;
}

double get_dist(int i, int j) {
  return sqrt(S * S + (a[i] - b[j]) * (a[i] - b[j]));
}

int solve_3points() {
  assert(A <= 5);
  assert(B <= 5);
  double best_sum = INF;
  int best_mask = 0;
  for (int mask = 0; mask < (1 << (A * B)); ++mask) {
    bool nbA[6], nbB[6];
    int s = 0;
    double sum = 0;
    for (int i = 0; i < A; ++i) nbA[i] = false;
    for (int j = 0; j < B; ++j) nbB[j] = false;
    for (int i = 0; i < A; ++i) for (int j = 0; j < B; ++j) {
      if (!(mask & (1 << (s++)))) continue;
      nbA[i] = true; nbB[j] = true;
      sum += get_dist(i, j);
    }
    if (sum >= best_sum) continue;
    bool ok = true;
    for (int i = 0; i < A; ++i) if (!nbA[i]) ok = false;
    for (int i = 0; i < B; ++i) if (!nbB[i]) ok = false;
    if (!ok) continue;
    best_sum = sum;
    best_mask = mask;
  }
  int s = 0;
  for (int i = 0; i < A; ++i) for (int j = 0; j < B; ++j) {
    if (!(best_mask & (1 << (s++)))) continue;
    ans[i].push_back(j);
  }
  return print_ans();
}

#define MAX 1111
double dp[MAX][MAX];
int prevI[MAX][MAX], prevJ[MAX][MAX];

int solve_10points() {
  assert(A <= 1000);
  assert(B <= 1000);
  for (int i = 0; i <= A; ++i) for (int j = 0; j <= B; ++j) dp[i][j] = INF;
  dp[1][1] = get_dist(0, 0);
  prevI[1][1] = prevJ[1][1] = -1;
  for (int i = 1; i <= A; ++i) for (int j = 1; j <= B; ++j) {
    if (i < A) {
      double dist = dp[i][j] + get_dist(i, j - 1);
      if (dist < dp[i + 1][j]) {
        dp[i + 1][j] = dist;
	prevI[i + 1][j] = i;
	prevJ[i + 1][j] = j;
      }
    }
    if (j < B) {
      double dist = dp[i][j] + get_dist(i - 1, j);
      if (dist < dp[i][j + 1]) {
        dp[i][j + 1] = dist;
	prevI[i][j + 1] = i;
	prevJ[i][j + 1] = j;
      }
    }
    if (i < A && j < B) {
      double dist = dp[i][j] + get_dist(i, j);
      if (dist < dp[i + 1][j + 1]) {
        dp[i + 1][j + 1] = dist;
	prevI[i + 1][j + 1] = i;
	prevJ[i + 1][j + 1] = j;
      }
    }
  }
  int i = A, j = B;
  while (i != -1) {
    ans[i - 1].push_back(j - 1);
    int ni = prevI[i][j], nj = prevJ[i][j];
    i = ni; j = nj;
  }
  return print_ans();
}

int solve_greedy() {
  int i = 0, j = 0;
  while (i < A || j < B) {
    if (j == B || (i < A && a[i] < b[j])) {
      double dist1 = INF, dist2 = INF;
      if (j) dist1 = get_dist(i, j - 1);
      if (j < B) dist2 = get_dist(i, j);
      if (dist2 <= dist1) ans[i].push_back(j++);
      else ans[i].push_back(j - 1);
      i++;
    }
    else {
      double dist1 = INF, dist2 = INF;
      if (i) dist1 = get_dist(i - 1, j);
      if (i < A) dist2 = get_dist(i, j);
      if (dist2 <= dist1) ans[i++].push_back(j);
      else ans[i - 1].push_back(j);
      j++;
    }
  }
  return print_ans();
}

#define MAGIC 200

double Dp[2][MAXN];
double DP[MAXN / MAGIC + 1][MAXN];
double local[MAGIC + 1][MAXN];
int PrevI[MAGIC + 1][MAXN], PrevJ[MAGIC + 1][MAXN];

int solve_better() {
  int layers = 0;
  for (int j = 0; j <= B; ++j) Dp[1][j] = INF;
  Dp[1][1] = get_dist(0, 0);
  for (int i = 1; i <= A; ++i) {
    int act = i % 2, nact = 1 - act;
    if (i % MAGIC == 1) {
      layers++;
      for (int j = 0; j <= B; ++j) DP[i / MAGIC][j] = Dp[act][j];
    }
    for (int j = 0; j <= B; ++j) Dp[nact][j] = INF;
      for (int j = 1; j <= B; ++j) {
      if (i < A) {
        double dist = Dp[act][j] + get_dist(i, j - 1);
        if (dist < Dp[nact][j]) Dp[nact][j] = dist;
      }
      if (j < B) {
        double dist = Dp[act][j] + get_dist(i - 1, j);
        if (dist < Dp[act][j + 1]) Dp[act][j + 1] = dist;
      }
      if (i < A && j < B) {
        double dist = Dp[act][j] + get_dist(i, j);
        if (dist < Dp[nact][j + 1]) Dp[nact][j + 1] = dist;
      }
    }
  }
  int I = A, J = B;
  for (int l = layers - 1; l >= 0; --l) {
    for (int i = 0; i <= MAGIC; ++i) for (int j = 0; j <= B; ++j) {
      local[i][j] = INF;
      PrevI[i][j] = -1; PrevJ[i][j] = -1;
    }
    for (int j = 0; j <= B; ++j) local[0][j] = DP[l][j];    
    for (int i = 0; i <= MAGIC; ++i) for (int j = 1; j <= B; ++j) {
      int ii = MAGIC * l + i + 1;
      if (ii > A) break;
      if (ii < A) {
        double dist = local[i][j] + get_dist(ii, j - 1);
        if (dist <= local[i + 1][j]) {
          local[i + 1][j] = dist;
	  PrevI[i + 1][j] = ii;
	  PrevJ[i + 1][j] = j;
        }
      }
      if (j < B) {
        double dist = local[i][j] + get_dist(ii - 1, j);
        if (dist <= local[i][j + 1]) {
          local[i][j + 1] = dist;
	  PrevI[i][j + 1] = ii;
	  PrevJ[i][j + 1] = j;
        }
      }
      if (ii < A && j < B) {
        double dist = local[i][j] + get_dist(ii, j);
        if (dist <= local[i + 1][j + 1]) {
          local[i + 1][j + 1] = dist;
	  PrevI[i + 1][j + 1] = ii;
	  PrevJ[i + 1][j + 1] = j;
        }
      }
    }
    /*
    for (int i = 0; i <= MAGIC; ++i) {
      int ii = MAGIC * l + i + 1;
      if (ii > A) break;
      printf("ii: %d,", ii);
      for (int j = 0; j <= B; ++j) {
        printf(" %lf(%d %d)", local[i][j], PrevI[i][j], PrevJ[i][j]);
      }
      printf("\n");
    }
    */
    while (true) {
      ans[I - 1].push_back(J - 1);
      int ni = PrevI[I - MAGIC * l - 1][J], nj = PrevJ[I - MAGIC * l - 1][J];
      if (ni == -1) break;
      I = ni; J = nj;
    }
  }
  return print_ans();
}

int main(int argv, char *argc[]) {
  scanf("%lld%lld%lld%lld", &L, &S, &A, &B);
  assert(1 <= L && L <= 2000000000);
  assert(1 <= S && S <= 1000);
  assert(1 <= A && A <= 20000);
  assert(1 <= B && B <= 20000);
  for (int i = 0; i < A; ++i) {
    scanf("%lld", a + i);
    assert(0 <= a[i] && a[i] <= L);
    if (i) assert(a[i] > a[i - 1]);
  }
  for (int i = 0; i < B; ++i) {
    scanf("%lld", b + i);
    assert(0 <= b[i] && b[i] <= L);
    if (i) assert(b[i] > b[i - 1]);
  }

  // return solve_3points();
  // return solve_10points();
  return solve_greedy(); // nekorektni reseni
  // return solve_better();
}
